#ifndef PD8255_H_INCLUDED
#define PD8255_H_INCLUDED

#include "pc6001v.h"
#include "device.h"

#include "p6device.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class D8255 {
protected:
	BYTE PortA;						// |[gA
	BYTE PortB;						// |[gB
	BYTE PortC;						// |[gC
	
	BYTE PortAbuf;					// |[gAobt@(8049̓͂ꎞIɃb`)
	
	int ModeA;						// O[vA[h
	int ModeB;						// O[vB[h
	
	BOOL PortAdir;					// |[gA         o͐ TRUE:(ǂ) FALSE:o()
	BOOL PortBdir;					// |[gB         o͐ TRUE:(ǂ) FALSE:o()
	BOOL PortC1dir;					// |[gC(bit0-3) o͐ TRUE:(ǂ) FALSE:o()
	BOOL PortC2dir;					// |[gC(bit4-7) o͐ TRUE:(ǂ) FALSE:o()
	
	BOOL HSINT0;					// INT0
	BOOL HSWINT0;					// WINT0
	BOOL HSRINT0;					// RINT0
	BOOL HSSTB0;					// STB0
	BOOL HSIBF0;					// IBF0
	BOOL HSDAK0;					// DAK0
	BOOL HSOBF0;					// OBF0
	
	BOOL RIE0;						// RIE0
	BOOL WIE0;						// WIE0
	
	// o͏֐
	virtual void JobWriteA( BYTE ){}
	virtual void JobWriteB( BYTE ){}
	virtual void JobWriteC1( BYTE ){}	// 
	virtual void JobWriteC2( BYTE ){}	// 
	virtual void JobWriteD( BYTE ){}	// rbgZbg/Zbĝ
	virtual void JobReadA(){}
	virtual void JobReadB(){}
	virtual void JobReadC(){}
	
	void SetMode( BYTE );			// [hݒ
	
public:
	D8255();						// RXgN^
	virtual ~D8255();				// fXgN^
	
	BOOL Init( void );				// 
	
	void Reset();					// Zbg
	
	// o͊֐
	void WriteA( BYTE );
	void WriteB( BYTE );
	void WriteC( BYTE );
	void WriteD( BYTE );			// Rg[|[go
	BYTE ReadA();
	BYTE ReadB();
	BYTE ReadC();
	
	// [h2nhVFCNp
	void WriteAE( BYTE );			// PartA Cg(ӑ)
	BYTE ReadAE();					// PartA [h(ӑ)
	BOOL GetIBF();					// IBF擾
	BOOL GetOBF();					// OBF擾
};


class PIO6 : public P6DEVICE, public Device, public D8255, public IDoko {
private:
	// o͏֐
	void JobWriteA( BYTE );
	void JobWriteC1( BYTE );
	void JobWriteD( BYTE );
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	inline void Out90H( int, BYTE data ){ WriteA( data ); }
	inline void Out91H( int, BYTE data ){ WriteB( data ); }
	inline void Out92H( int, BYTE data ){ WriteC( data ); }
	inline void Out93H( int, BYTE data ){ WriteD( data ); }
	inline BYTE In90H( int ){ return ReadA(); }
	inline BYTE In92H( int ){ return ReadC(); }
	inline BYTE In93H( int ){ return 0xff; }
	
	inline void OutPBH( int, BYTE data ){ WriteAE( data ); }
	inline BYTE InPBH( int ){ return ReadAE(); }
	inline BYTE InIBF( int ){ return GetIBF() ? 1 : 0; }
	inline BYTE InOBF( int ){ return GetOBF() ? 1 : 0; }
	
public:
	PIO6( VM6 *, const ID& );		// RXgN^
	~PIO6();						// fXgN^
	
	// foCXID
	enum IDOut{ out90H=0, out91H, out92H, out93H, outPBH         };
	enum IDIn {  in90H=0,  in92H,          in93H,  inPBH,  inIBF,  inOBF };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ǂłSAVE
	BOOL DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};

#endif	// PD8255_H_INCLUDED
